# utilizziamo un dataset presente su UCI che registra i tassi di diabete in un particolare gruppo etnico degli Stati Uniti 
diab <- read.table("https://archive.ics.uci.edu/ml/machine-learning-databases/pima-indians-diabetes/pima-indians-diabetes.data", sep = ",")

# estraiamo un dataset di train e uno di test
train <- diab[1:500,]
test <- diab[501:768,]

# creiamo il modello predittivo. La variabile che registra la presenza o assenza di diabete, è l'ultima, la V9
mod <- glm(V9 ~., data=train, family=binomial(logit))

# testiamo il modello predittivo sul dataset di test
pred <- predict(mod, test, type='response')

# verifichiamo le differenze con i dati effettivi e misuriamo l'errore
val <- test[, 9]
sqrt(mean((pred - val)^2))

# visualizziamo una parte dei dati a confronto:
cbind(round(pred), val)

# creiamo la crosstab
table(round(pred), test$V9)
