install.packages("nnet")
library(nnet)

set.seed(12345)
random <- runif(nrow(iris))
iris2 <- iris[order(random),]


train <- iris2[1:100,]
test <- iris2[101:150,]


nn <- nnet(Species ~., train, size = 1, rang = 0.1, maxit = 200)

summary(nn)

pred <- predict(nn, test, type = "class")

table(test$Species, pred)




#########
# neuralnet

library(mlbench)

library(neuralnet)

data(PimaIndiansDiabetes)

pid <- PimaIndiansDiabetes

pid$diabetes <- ifelse(pid$diabetes == "pos", 1, 0)

train <- pid[1:500,]

test <- pid[501:768,]

nn2 <- neuralnet(diabetes ~ pregnant + glucose + pressure + triceps + insulin + mass + pedigree + age, train, err.fct = "ce", linear.output = FALSE, likelihood = TRUE)

# alternativa
n <- names(pid)
formula <- as.formula(paste("diabetes ~", paste(n[!n %in% "diabetes"], collapse = " + ")))
neuralnet(formula, train, err.fct = "ce", linear.output = FALSE, likelihood = TRUE)


plot(nn2)

nn2$net.result
nn2$weights

nn2$result.matrix

nn2$covariate


nn_test <- compute(nn2, test[,1:8])

table(nn_test$net.result, test$diabetes)

