install.packages("adabag")
library(adabag)

install.packages("kernlab")
library(kernlab)
data(spam)

set.seed(12345)
random <- runif(nrow(spam))
spam2 <- spam[order(random),]

# creiamo il modello di bagging
adbg <- bagging(type ~., data = spam2[1:3500,])

# visualizziamo qualche informazione sul modello creato
summary(adbg)


# creiamo un oggetto di test
test <- spam2[3501:4601,]

# utilizziamo il modello predittivo per inferire la classificazione degli item nell'oggetto test
pred <- predict(adbg, test, type = "class")

# se stampiamo pred possiamo visualizzare la matrice di confusione e il tasso di errore
pred
