install.packages("ada")
library(ada)

# mettiamo il set.seed() per la replicabilità dei risultati
set.seed(12345)

# mescoliamo i dati e creiamo gli ogetti di train e di test
data(spam)
random <- runif(nrow(spam))
spam2 <- spam[order(random),]

train <- spam2[1:3500,]
test <- spam2[3501:4601,]

# creiamo il modello
ada_test <- ada(type ~., train, loss = "logistic")

# visualizziamo il modello creato
ada_test

# prediciamo la classe dell'oggetto di test
pred <- predict(ada_test, test)

# creiamo la matrice di confusione per visualizzare i risultati
table(pred, test$type)
