install.packages("xgboost")
library(xgboost)

# digitando questo codice, possiamo visualizzare una serie di esempi creati tramite xgboost
demo(package = "xgboost")

demo("basic_walkthrough", package = "xgboost")


# carichiamo train e test set
data(agaricus.train, package='xgboost')
data(agaricus.test, package='xgboost')

train <- agaricus.train
test <- agaricus.test

# visualizziamo qualche informazione sulla struttura dei dati
str(train$data)


xgb <- xgboost(data = train$data, label = train$label, nround = 2, objective = "binary:logistic")

pred <- predict(xgb, test$data)

print(length(pred))

cv <- xgb.cv(data = train$data, nfold = 5, label = train$label, nround = 2, objective = "binary:logistic", eval_metric = "auc")
