library(topicmodels)
library(tm)

the100 <- VCorpus(DirSource(directory = "/Users/valentinaporcu/Downloads/MIO/the100/txt", encoding = "UTF-8"))
the100 <- tm_map(the100, content_transformer(tolower))
the100 <- tm_map(the100, content_transformer(stripWhitespace))
the100 <- tm_map(the100, content_transformer(removeWords), stopwords("english"))
the100 <- tm_map(the100, content_transformer(removeWords), c("rhetoriccom", "will"))
the100 <- tm_map(the100, content_transformer(stemDocument))
the100 <- tm_map(the100, content_transformer(removePunctuation))
the100 <- tm_map(the100, content_transformer(PlainTextDocument))


dtm <- DocumentTermMatrix(the100)
topics <- LDA(dtm, k = 4)

terms(topics, 8)


posterior_lda <- posterior(topics)
lda_topics <- data.frame(t(posterior_lda$topics))



